Name:          apache-commons-weaver
Version:       1.3
Release:       1%{?dist}
Summary:       Apache Commons Weaver
License:       ASL 2.0
URL:           https://commons.apache.org/proper/commons-weaver/
Source0:       http://www.apache.org/dist/commons/weaver/source/commons-weaver-%{version}-src.tar.gz

BuildRequires: maven-local
BuildRequires: mvn(commons-io:commons-io)
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(org.apache.ant:ant)
BuildRequires: mvn(org.apache.ant:ant-launcher)
BuildRequires: mvn(org.apache.commons:commons-collections4)
BuildRequires: mvn(org.apache.commons:commons-lang3)
BuildRequires: mvn(org.apache.commons:commons-parent:pom:)
BuildRequires: mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires: mvn(org.apache.maven:maven-core)
BuildRequires: mvn(org.apache.maven:maven-plugin-api)
BuildRequires: mvn(org.apache.maven.plugins:maven-antrun-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-clean-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-dependency-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-invoker-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-plugin-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-release-plugin)
BuildRequires: mvn(org.apache.maven.plugin-tools:maven-plugin-annotations)
BuildRequires: mvn(org.apache.xbean:xbean-asm-util)
BuildRequires: mvn(org.apache.xbean:xbean-finder)
BuildRequires: mvn(org.codehaus.mojo:build-helper-maven-plugin)
BuildRequires: mvn(org.codehaus.plexus:plexus-utils)
BuildRequires: mvn(org.eclipse.aether:aether-api)
BuildRequires: mvn(org.eclipse.aether:aether-util)
BuildRequires: mvn(org.eclipse.jdt.core.compiler:ecj)
BuildRequires: mvn(org.hamcrest:hamcrest-library)
# BuildRequires: mvn(org.ow2.asm:asm-debug-all)
BuildRequires: mvn(org.ow2.asm:asm)
BuildRequires: mvn(org.ow2.asm:asm-analysis)
BuildRequires: mvn(org.ow2.asm:asm-commons)
BuildRequires: mvn(org.ow2.asm:asm-tree)
BuildRequires: mvn(org.ow2.asm:asm-util)

BuildArch:     noarch

%description
Apache Commons Weaver provides an easy way to enhance compiled Java
classes by generating ("weaving") bytecode into those classes.

%package antlib
Summary:       Apache Commons Weaver Ant task library

%description antlib
The Commons Weaver Antlib provides tasks and
types to facilitate the integration of
Commons Weaver into your Apache Ant-based
build process.

%package base
Summary:       Apache Commons Weaver Base Parent POM

%description base
Apache Commons Weaver Base Parent POM.

%package maven-plugin
Summary:       Apache Commons Weaver Maven Plugin

%description maven-plugin
The Commons Weaver plugin for Apache Maven aims to
integrate Weaver as smoothly as possible for Maven
users. 

%package modules-parent
Summary:       Apache Commons Weaver Modules Parent POM

%description modules-parent
Apache Commons Weaver Modules POM aggregator project.

%package normalizer
Summary:       Apache Commons Weaver Normalizer

%description normalizer
The Normalizer module merges identical anonymous class definitions
into a single type, thereby "normalizing" them and reducing their
collective footprint on your archive and more importantly on your JVM.

%package parent
Summary:       Apache Commons Weaver Parent POM

%description parent
Apache Commons Weaver Parent POM.

%package privilizer
Summary:       Apache Commons Weaver Privilizer Weaver

%description privilizer
Implements the Apache Commons Weaver SPI for the
Privilizer module

%package privilizer-api
Summary:       Apache Commons Weaver Privilizer API

%description privilizer-api
Commons Weaver Privilizer API provides machinery to
automate the handling of Java Security access
controls in code.

%package privilizer-parent
Summary:       Apache Commons Weaver Privilizer Parent POM

%description privilizer-parent
Privilizer provides machinery to automate the
handling of Java Security access controls in code.

%package processor
Summary:       Apache Commons Weaver Processor

%description processor
Defines the Apache Commons Weaver SPI as well as the basic build-time
(filesystem-based) processors that detect, configure, and invoke
available modules.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n commons-weaver-%{version}-src

# Unwanted tasks
%pom_remove_plugin -r :maven-shade-plugin
%pom_remove_plugin :maven-site-plugin
%pom_remove_plugin -r :maven-source-plugin
%pom_remove_plugin -r :japicmp-maven-plugin
%pom_remove_plugin :maven-scm-publish-plugin
%pom_xpath_remove "pom:plugin[pom:artifactId = 'maven-javadoc-plugin']/pom:executions" parent

# Useless modules
%pom_disable_module build-tools
%pom_disable_module dist

%pom_change_dep -r :xbean-finder-shaded :xbean-finder:4.5
sed -i "s|org.apache.xbean.asm5|org.objectweb.asm|" \
 processor/src/main/java/org/apache/commons/weaver/Finder.java

%pom_add_dep org.apache.xbean:xbean-asm-util:4.5 processor
%pom_add_dep org.ow2.asm:asm:'${asm.version}' processor
#%% pom_add_dep org.ow2.asm:asm-commons:'${asm.version}' processor
%pom_xpath_remove "pom:profiles" modules/privilizer/weaver
%pom_add_dep org.ow2.asm:asm:'${asm.version}' modules/privilizer/weaver
%pom_add_dep org.ow2.asm:asm-util:'${asm.version}' modules/privilizer/weaver

%pom_xpath_remove "pom:profiles" modules/normalizer

%pom_remove_plugin -r :maven-invoker-plugin modules/privilizer/weaver

# Disable ecj support, Class not found: org.eclipse.jdt.core.JDTCompilerAdapter
%pom_change_dep org.eclipse.jdt.core.compiler:ecj com.sun:tools:1.8.0 modules/normalizer
sed -i '/org.eclipse.jdt.core.JDTCompilerAdapter/d' \
 modules/normalizer/pom.xml

chmod 644 *.txt

%mvn_package :commons-weaver-normalizer::tests: commons-weaver-normalizer
%mvn_package :commons-weaver-processor::tests: commons-weaver-processor

%build

%mvn_build -s

%install
%mvn_install

%files antlib -f .mfiles-commons-weaver-antlib
%files base -f .mfiles-commons-weaver-base
%license LICENSE.txt NOTICE.txt

%files maven-plugin -f .mfiles-commons-weaver-maven-plugin
%files modules-parent -f .mfiles-commons-weaver-modules-parent
%files normalizer -f .mfiles-commons-weaver-normalizer
%license LICENSE.txt NOTICE.txt

%files parent -f .mfiles-commons-weaver-parent
%license LICENSE.txt NOTICE.txt

%files privilizer -f .mfiles-commons-weaver-privilizer
%files privilizer-api -f .mfiles-commons-weaver-privilizer-api
%license LICENSE.txt NOTICE.txt

%files privilizer-parent -f .mfiles-commons-weaver-privilizer-parent
%license LICENSE.txt NOTICE.txt

%files processor -f .mfiles-commons-weaver-processor
%doc RELEASE-NOTES.txt
%license LICENSE.txt NOTICE.txt

%files javadoc -f .mfiles-javadoc
%license LICENSE.txt NOTICE.txt

%changelog
* Fri Oct 28 2016 gil cattaneo <puntogil@libero.it> 1.3-1
- update to 1.3

* Sun Feb 07 2016 gil cattaneo <puntogil@libero.it> 1.2-1
- update to 1.2

* Tue Jan 05 2016 gil cattaneo <puntogil@libero.it> 1.2-0.1.RC1
- update to 1.2_RC1

* Tue Jan 05 2016 gil cattaneo <puntogil@libero.it> 1.1-2
- fix *.txt permissions

* Fri Jun 05 2015 gil cattaneo <puntogil@libero.it> 1.1-1
- initial rpm
